[LightOJ 1364] Expected Cards (高维期望DP)

2024-06-21 19:48

本文主要是介绍[LightOJ 1364] Expected Cards (高维期望DP),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

LightOJ - 1364

一副扑克牌,不断地从中抽牌
要求四种花色都至少要有给定的张数
其中如果抽到了王牌,可以将其变为任意花色
求满足条件时,抽出的期望张数


刚开始想错了,两张王牌并非在一开始就给定了
而是在游戏中可以视当前情况选择着变的
这两种方式是不一样的

由于牌数其实并不会很多,
复杂度乘一乘发现才 107 级别的,所以直接暴力DP

将两张王牌当前变成了什么,四种花色有多少张全部表示成状态
这样就是一个六维的dp数组,然后暴力转移即可
当抽到王牌的时候,对它变成各种牌的情况取 min
抽到其他牌的期望全部加起来

#pragma comment(linker, "/STACK:102400000,102400000")
#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <cctype>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <string>
using namespace std;
typedef pair<int,int> Pii;
typedef long long LL;
typedef unsigned long long ULL;
typedef double DBL;
typedef long double LDBL;
#define MST(a,b) memset(a,b,sizeof(a))
#define CLR(a) MST(a,0)
#define SQR(a) ((a)*(a))
#define PCUT puts("----------")const DBL eps=1e-8;
int A[4];
DBL dp[5][5][16][16][16][16];DBL DP(int,int,int,int,int,int);int main()
{#ifdef LOCALfreopen("in.txt", "r", stdin);
//  freopen("out.txt", "w", stdout);#endifint T;scanf("%d", &T);for(int ck=1; ck<=T; ck++){int ok=0;for(int i=0; i<4; i++){scanf("%d", &A[i]);if(A[i] > 13) ok += A[i]-13;}if(ok>2) {printf("Case %d: -1\n", ck); continue;}MST(dp,0xc0);DBL ans = DP(0,0,0,0,0,0);printf("Case %d: %.7f\n", ck, ans);}return 0;
}DBL DP(int J0, int J1, int C,int D,int H,int S)
{if(dp[J0][J1][C][D][H][S] > eps) return dp[J0][J1][C][D][H][S];if(C>=A[0] && D>=A[1] && H>=A[2] && S>=A[3]) return dp[J0][J1][C][D][H][S] = 0.0;DBL tot = 54-C-D-H-S, lc=13-C, ld=13-D, lh=13-H, ls=13-S;if(J0==1) lc++; if(J1==1) lc++;if(J0==2) ld++; if(J1==2) ld++;if(J0==3) lh++; if(J1==3) lh++;if(J0==4) ls++; if(J1==4) ls++;DBL res=0.0, tem;if(!J0){tem = 1e9;tem = min(tem, (DP(1, J1, C+1, D, H, S)+1)/tot);tem = min(tem, (DP(2, J1, C, D+1, H, S)+1)/tot);tem = min(tem, (DP(3, J1, C, D, H+1, S)+1)/tot);tem = min(tem, (DP(4, J1, C, D, H, S+1)+1)/tot);res += tem;}if(!J1){tem = 1e9;tem = min(tem, (DP(J0, 1, C+1, D, H, S)+1)/tot);tem = min(tem, (DP(J0, 2, C, D+1, H, S)+1)/tot);tem = min(tem, (DP(J0, 3, C, D, H+1, S)+1)/tot);tem = min(tem, (DP(J0, 4, C, D, H, S+1)+1)/tot);res += tem;}if(lc) res += (DP(J0, J1, C+1, D, H, S)+1)*lc/tot;if(ld) res += (DP(J0, J1, C, D+1, H, S)+1)*ld/tot;if(lh) res += (DP(J0, J1, C, D, H+1, S)+1)*lh/tot;if(ls) res += (DP(J0, J1, C, D, H, S+1)+1)*ls/tot;return dp[J0][J1][C][D][H][S] = res;
}

这篇关于[LightOJ 1364] Expected Cards (高维期望DP)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1082171

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o